/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.sql.SQLException;
import java.io.PrintWriter;
import java.io.PrintStream;

/**
 * uqOvuqG[vONXB
 * @version     1.1 99/09/22
 * @author      Tadayoshi Maekawa, Sun Microsystems Inc.
 */
public class NestedException extends Exception {
    /* -------== tB[h ==------- */
    /**
     * ƂȂOB
     */
    Throwable org;

    /* -------== RXgN^ ==------- */
    /**
     * bZ[W Throwable IuWFNgɂƂRXgN^B
     * @param m bZ[W
     * @param t Throwable IuWFNg
     */
    protected NestedException(String m, Throwable t) {
        super(m);
        org = t;
    }

    /* -------== \bh ==------- */
    /**
     * Throwable ̃X^bNg[XWG[ɏo͂B
     */
    public void printStackTrace() {
        printStackTrace(System.err);
    }

    /**
     * Throwable ̃X^bNg[Xw肳ꂽ writer ɏo͂B
     * @param w writer
     */
    public void printStackTrace(PrintWriter w) {
        super.printStackTrace(w);
        if (org != null) {
            if (org instanceof SQLException) {
                SQLException sqle;
                for (sqle = (SQLException)org; sqle != null;
                     sqle = sqle.getNextException()) {
                    w.println("-------------------");
                    sqle.printStackTrace(w);
                }
            } else {
                w.println("-------------------");
                org.printStackTrace(w);
            }
        }
    }

    /**
     * Throwable ̃X^bNg[Xw肳ꂽ stream ɏo͂B
     * @param s stream
     */
    public void printStackTrace(PrintStream s) {
        printStackTrace(new PrintWriter(s, true));
    }
}
