/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.Frame;
import java.sql.*;
import java.util.Properties;

/**
 * DB OCʁB
 *
 * @version     1.3, 99/09/24
 * @author      Tadayoshi Maekawa, Sun Microsystems K.K.
 */
public class Login {
    /**
     * f[^x[XERlNVB
     */
    Connection conn;

    /**
     * GUIB
     */
    LoginUI ui;

    /**
     * ڑvpeBB
     */
    Properties props;

    /**
     * et[ƃ[_̃tOADB ڑpvpeBɎ
     * RXgN^B
     * @param fr et[
     * @param mf [_̃tO
     * @param pr ڑvpeB
     */
    public Login(Frame fr, boolean mf, Properties pr) {
        props = (pr == null) ? new Properties() : (Properties)pr.clone();
        ui = new LoginUI(fr, mf, this);
        ui.setVisible(true);
    }

    /**
     * f[^x[XRlNVԂB
     */
    public Connection getConnection() {
        return conn;
    }

    /**
     * f[^x[Xւ̐ڑsB
     */
    protected void connectDatabase() {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        } catch (ClassNotFoundException ex) {
            // ł͖
        }
        try {
            props.put("user", ui.getTextUserNameField());
            props.put("password", ui.getTextPasswordField());
            conn = DriverManager.getConnection(
                ui.getTextURLField(), props);
            SQLWarning warn = conn.getWarnings();
            while (warn != null) {
                ui.showError("SQLWarning:" + warn.getMessage());
                warn = warn.getNextWarning();
            }
        } catch (SQLException ex) {
            while (ex != null) {
                ui.showError(ex.getMessage());
                ex.printStackTrace();
                ex = ex.getNextException();
            }
        }
    }
}
